/* coding: utf-8 */
/* Copyright (C) 2020 SofTek Systems, Inc. */

//プロダクト一覧画面
function BootStrapTableCellStyle(value, row, index, field) {
    switch (field){
        case 'chkbox':
            return { classes: 'chk-box' };
        case 'product-name':
            return { classes: 'product-name text-left g-line-height-1_2' };
        case 'product-version-name':
            return { classes: 'version-name text-left g-line-height-1_2' };i
        case 'hosts':
            return { classes: 'product-hosts text-left' };
        case 'product-is-support-end':
            return { classes: 'product-is-support-end' };
        case 'link_to_pages':
            return { classes: 'product-link-to-pages' };
        default:
            return { classes: '' };
    }
}

function BootStrapTableRowStyle(row, index){
    return {
        classes: 'list_alternative'
    }
}

$(function(){
    const summaryTableId = 'products-summary-table';
    const summaryTableElm = $('#' + summaryTableId);
    const pageName = 'products';

    /*function submit_search_item(search_item, keyword){
        if(keyword.length > 0){
            reset_pages_checked_values();
            var filters = JSON.parse($('#pages_filters').val());
            filters[search_item] = String(keyword);
            $('#pages_filters').val(JSON.stringify(filters));
            $('#pages_offset').val('0');
            $('#pages_form').submit();
        }
    }*/

    const bindSummaryTableCheckBoxEvent = () => {
        $('#' + summaryTableId + ' .SelectProduct').on('change', function(){
            var chk_box = $(this);
            var prod_id = JSON.parse(chk_box.val());
            var selected_ids = JSON.parse($('#pages_checked').val());
            var all_prod_ids = JSON.parse($('#all-product-ids').val());
            if(chk_box.prop('checked')){
                selected_ids.push(prod_id);
            }else{
                var pid = prod_id['pid'];
                var vid = prod_id['vid'];
                var lpid = prod_id['lpid'];
                var lvid = prod_id['lvid'];
                for(var i = 0; i < selected_ids.length; i++){
                    var elm_val = selected_ids[i];
                    var is_hit = false
                    if(pid && (elm_val['pid'] == pid) ||
                        vid && (elm_val['vid'] == vid) ||
                        lpid && (elm_val['lpid'] == lpid) ||
                        lvid && (elm_val['lvid'] == lvid)
                    ){
                        selected_ids.splice(i, 1);
                        break;
                    }
                }
            }
            $('#pages_checked').val(JSON.stringify(selected_ids));
            if(all_prod_ids.length === selected_ids.length){
                $('#allSelect').prop('checked', true);
                $('#pages_all_checked').val('true');
            }else{
                $('#allSelect').prop('checked', false);
                $('#pages_all_checked').val('false');
            }
        });
    }

    //サマリー表のホスト名押下でフィルタ
    const FilterHostLink = (clickedElm, filters, _) => {
        const searchName = clickedElm.attr('data-displayname');
        filters['search_hosts'] = searchName;
        $('#search_hosts_field').val(searchName);
    };

    const enableFilterHostLink = () => {
        summaryTableFilter.enableFilterClick(
            `#${summaryTableId} .search-host-by-display-name`,
            'search_hosts', 
            FilterHostLink
        );
    }

    //サマリー表の動的処理のため(bootstrap-tableのため)にbindする。でないとイベントが効かない。
    const bindSummaryTableRowEvents = () => {
        enable_bootstrap_actions('#' + summaryTableId);
        bindSummaryTableCheckBoxEvent();
        enable_dropdown_balloon(summaryTableId);
        /*$(`#${summaryTableId} .search-host-by-display-name`).on('click', function(e){
            e.preventDefault();
            submit_search_item('search_hosts', $(this).attr('data-displayname'));
        });*/
        enableFilterHostLink();
    };

    init_sidfm();
    //enable_dropdown_balloon();
    sticky_control('SummaryTable', pageName);
    activate_sidebar_item('sidebar-item-products-manip');
    set_style_for_ActionArea_on_filter_dropdown_event();

    /*const bindSortSummaryTableEvents = () => {
        $(`#${summaryTableId} .sort-products-name`).on('click', function() {
            execSortSummaryTable('product-name', $(this))
        });
        $(`#${summaryTableId} .sort-products-is-support-end`).on('click', function() {
            execSortSummaryTable('product-is-support-end', $(this))
        });
        $(`#${summaryTableId} .sort-products-version-name`).on('click', function() {
            execSortSummaryTable('product-version-name', $(this))
        });
    };*/

    const dynamicSummaryTable = new DynamicSummaryTable({
        summaryTableId,
        bindSummaryTableRowEventsFunction: bindSummaryTableRowEvents,
        pageName,
        allFilteredIdsId: 'all-product-ids',
        chkboxSelector: `#${summaryTableId} .SelectProduct`,
        allChkboxSelector: `#${summaryTableId} .allSelect`,
    });

    const establishConsistencySummaryTableCheckBox = () => {
        var pages_checked = JSON.parse($('#pages_checked').val());
        var all_product_ids = JSON.parse($('#all-product-ids').val());
        if(pages_checked.length === all_product_ids.length && all_product_ids.length > 0){
            $('#allSelect').prop('checked', true);
        }else{
           $('#allSelect').prop('checked', false);
        }

        $('#ProductTable').find('.SelectProduct').prop('checked', false);
        for(var i = 0; i < pages_checked.length; i++){
            var id = pages_checked[i];
            var pid = id['pid'];//どれか１つ
            var vid = id['vid'];
            var lpid = id['lpid'];
            var lvid = id['lvid'];
            $('#ProductTable').find('.SelectProduct').each(function(){
                var elm = $(this);
                var elm_val = JSON.parse(elm.val());
                var is_hit = false
                if(pid && (elm_val['pid'] == pid) ||
                    vid && (elm_val['vid'] == vid) ||
                    lpid && (elm_val['lpid'] == lpid) ||
                    lvid && (elm_val['lvid'] == lvid)
                ){
                    $(this).prop('checked', true);
                    return false;
                }
            });
        }
    };

    $(window).on('pageshow', function(){
        establishConsistencySummaryTableCheckBox();
    });

    $('#pages_form').on('submit', function(){ set_summary_table_lines(pageName, $('#pages_per_page').val()) });   

    const summaryTableFilter = new SummaryTableFilter({dynamicSummaryTable});
    //サマリーテーブルの検索
    summaryTableFilter.enableFilterText(
       '#filter_product_name',
       '#filter_product_name_reset',
       { fieldSelector: '#search_product_name_field' },
       'search_products'
    ); //プロダクト名検索

    summaryTableFilter.enableFilterText(
       '#filter_version',
       '#filter_version_reset',
       { fieldSelector: '#search_version_field' },
       'search_versions'
    ); //バージョン名検索

    summaryTableFilter.enableFilterText(
       '#filter_hosts',
       '#filter_hosts_reset',
       { fieldSelector: '#search_hosts_field' },
       'search_hosts'
    ); //ホスト検索

    summaryTableFilter.enableResetAllFilters('#filter-clear'); //全リセット

    //ダウンロード
    $('#execute-download').on('click', function(){
        (async () => {
            const roleOrCategoryError = await dynamicSummaryTable.checkRolesAndCatsBeforeAction();
            if( roleOrCategoryError ) return;
            $('#download-order').val($('#pages_order').val());
            $('#download-filters').val($('#pages_filters').val());
            $('#download-product-ids').val($('#pages_checked').val());
            $('#form_download').submit();
        })();
    });
});
