#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

class CreateSidfmdCategories < ActiveRecord::Migration
  def change
    create_table :sidfmd_categories do |t|
      # カテゴリ名
      t.string :name, :null => false, :index => false
      # カテゴリの説明
      t.string :desc, :null => false
      # ユーザカテゴリの場合、ユーザIDを設定。nullならユーザカテゴリ以外。
      # 他ユーザに出力されないように注意。基本的にはscope経由でアクセス
      # すること。
      # なお、indexをnull fastでDB非依存で作成する方法が無いため、
      # orderの指定で対応する必要があることに注意。
      t.references :users, :index => true
      # システムカテゴリである場合はtrue
      t.boolean :is_system, :null => false, :index => false

      t.integer :lock_version, :default => 0, :null => false
      t.timestamps
    end

    create_table :sidfmd_categories_sidfmd_hosts do |t|
      t.references :sidfmd_category, :null => false, :index => true
      t.references :sidfmd_host, :null => false, :index => true
    end

  end
end
