#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

class AppendHostLimit < ActiveRecord::Migration
  # カテゴリ毎のホスト数制限の設定を追加
  def change
    change_table :sidfmd_categories do |t|
      # hostlim : カテゴリ毎のホスト数登録制限
      # チェックはホスト登録時、ホストのカテゴリ変更時、インポート時に
      # 行う。既に超過している場合には何もしない。
      # システムカテゴリについては常に無視する。
      # > 0 : 指定した数まで登録可能。指定はライセンス数の上限まで。
      #  なお、複数のカスタムカテゴリを指定した場合、指定した物の内、
      #  もっとも少ないhostlimに従う
      # 0: 登録不可 ※ 処理は > 0 と同一で問題無い。
      # nil: 制限無し
      t.integer :hostlim, :default => nil, :null => true
    end
  end
end
