require_dependency 'welcome_controller'

module SidfmPatches
  module WelcomeControllerPatch
    extend ActiveSupport::Concern

    included do
      alias_method_chain :index, :sidfm
    end

    def index_with_sidfm
      if User.current.anonymous? then
        redirect_to :controller => :account, :action => :login, :back_url => sidfm_index_path and return
      else
        redirect_to :controller => :sidfm, :action => :index and return
      end
    end

  end
end

ActionDispatch::Reloader.to_prepare do
  unless WelcomeController.included_modules.include?(SidfmPatches::WelcomeControllerPatch)
    WelcomeController.send(:include, SidfmPatches::WelcomeControllerPatch)
  end
end
