# -*- coding: utf-8 -*-

class ModifySidfmdRuleActions < ActiveRecord::Migration

  def up
    # アクションで処理する対象のデータを指定
    #  0: 脆弱性一覧(default)
    #  1: ホスト一覧
    #  2: 脆弱性同期時に新規登録された脆弱性一覧
    #  3: 脆弱性同期時に値が変更された脆弱性一覧
    #  4: 脆弱性同期時に対策済みに変更された脆弱性一覧
    #  それ以外: 無効
    add_column :sidfmd_rule_actions, :target, :integer, :default => 0, :null => false, :index => true
    # 対象データのサイズが0だった場合に、actionの処理を実行するか
    #  true: する(default)
    #  false: しない
    #  ※ データがあるときだけメール送信する、のような動作を実現するための機能。
    add_column :sidfmd_rule_actions, :proc_empty, :boolean, :default => true, :null => false, :index => true

    # 攻撃コードの有無でフィルタする条件
    create_table :sidfmd_rule_c_cvss_exploitables do |t|
      t.references :sidfmd_rule_cond, foreign_key: true, index: true, null: false

      # 攻撃コードの有無のチェック
      # true: 有り
      # false: 無し
      t.boolean :value, null: false, default: true

      # 変化があった場合(false>true, true>false)のみ、条件が成立する
      t.boolean :is_change, null: false, default: false
    end

  end

  def down
    drop_table :sidfmd_rule_c_cvss_exploitables
    remove_column :sidfmd_rule_actions, :target
    remove_column :sidfmd_rule_actions, :proc_empty
  end

end
